package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteSecurityGroupLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteSecurityGroupLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteSecurityGroupLogic {
	return &DeleteSecurityGroupLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteSecurityGroupLogic) DeleteSecurityGroup(req *types.DeleteSecurityGroupReq) (resp *types.DeleteSecurityGroupResp, err error) {
	// todo: add your logic here and delete this line
	DeleteSecurityGroupReq := &openstack.DeleteSecurityGroupReq{}
	err = copier.CopyWithOption(DeleteSecurityGroupReq, req, copier.Option{Converters: utils.Converters})
	DeleteSecurityGroupResp, err := l.svcCtx.OpenstackRpc.DeleteSecurityGroup(l.ctx, DeleteSecurityGroupReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteSecurityGroupResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteSecurityGroupResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
